using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
 
namespace ExcelWorksheetEvents
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("7B8757B3-4D16-4DEB-ABDC-4C0BF91B14D1"), ProgId("ExcelWorksheetEvents.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule(System.ComponentModel.IContainer container)
        {
            // This call is required by the Component Designer
            container.Add(this);
            InitializeComponent();
 
            // TODO: Add any initialization after the InitializeComponent call
        }

		private AddinExpress.MSO.ADXExcelAppEvents adxExcelEvents;
 
        public AddinModule()
        {
            InitializeComponent();
        }
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.adxExcelEvents = new AddinExpress.MSO.ADXExcelAppEvents(this.components);
			// 
			// adxExcelEvents
			// 
			this.adxExcelEvents.WorkbookActivate += new AddinExpress.MSO.ADXHostActiveObject_EventHandler(this.adxExcelEvents_WorkbookActivate);
			this.adxExcelEvents.SheetActivate += new AddinExpress.MSO.ADXHostActiveObject_EventHandler(this.adxExcelEvents_SheetActivate);
			// 
			// AddinModule
			// 
			this.AddinName = "ExcelWorksheetEvents";
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;
			this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);
			this.AddinBeginShutdown += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinBeginShutdown);

		}
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		private ExcelWorksheetEvents eventsObject = null;

		private Excel._Application ExcelApp
		{
			get
			{
				return HostApplication as Excel._Application;
			}
		}

		private void adxExcelEvents_SheetActivate(object sender, object hostObj)
		{
			eventsObject.ConnectTo(hostObj, true);
		}

		private void adxExcelEvents_WorkbookActivate(object sender, object hostObj)
		{
			object sheet = null;
			try
			{
				sheet = (hostObj as Excel.Workbook).ActiveSheet;
			}
			catch
			{
			}
			if (sheet != null)
				eventsObject.ConnectTo(sheet, true);
			else
				eventsObject.RemoveConnection();
		}

		private void AddinModule_AddinStartupComplete(object sender, System.EventArgs e)
		{
			eventsObject = new ExcelWorksheetEvents(this);
		}

		private void AddinModule_AddinBeginShutdown(object sender, System.EventArgs e)
		{
			if (eventsObject != null)
				eventsObject.Dispose();
		}
 
    }
}

